

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.15.13. math_abs &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.15.14. now" href="now.html" />
    <link rel="prev" title="7.15.12. in_values" href="in_values.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/functions/math_abs.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="now.html" title="7.15.14. now"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="in_values.html" title="7.15.12. in_values"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" accesskey="U"><span class="section-number">7.15. </span>Function</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.13. </span><code class="docutils literal notranslate"><span class="pre">math_abs</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="math-abs">
<h1><span class="section-number">7.15.13. </span><code class="docutils literal notranslate"><span class="pre">math_abs</span></code><a class="headerlink" href="#math-abs" title="Permalink to this headline">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.15.13.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<div class="versionadded">
<p><span class="versionmodified added">New in version 7.0.4.</span></p>
</div>
<p><code class="docutils literal notranslate"><span class="pre">math_abs</span></code> returns the absolute value of value.</p>
<p>To enable this function, register <code class="docutils literal notranslate"><span class="pre">functions/math</span></code> plugin by following the command:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>plugin_register functions/math
</pre></div>
</div>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.15.13.2. </span>Syntax<a class="headerlink" href="#syntax" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">math_abs</span></code> requires one argument - <code class="docutils literal notranslate"><span class="pre">target</span></code>.</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>math_abs(target)
</pre></div>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.15.13.3. </span>Usage<a class="headerlink" href="#usage" title="Permalink to this headline">¶</a></h2>
<p>Here is a schema definition and sample data.</p>
<p>Sample schema:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Shops TABLE_HASH_KEY ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Shops from_station COLUMN_SCALAR Int32
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Shops from_office COLUMN_SCALAR Int32
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>Sample data:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>load --table Shops
[
{&quot;_key&quot;: &quot;Coffee Shop&quot;,         &quot;from_station&quot;:  50},
{&quot;_key&quot;: &quot;Donut &amp; Coffee Shop&quot;, &quot;from_station&quot;: 400},
{&quot;_key&quot;: &quot;Cake &amp; Coffee Shop&quot;,  &quot;from_station&quot;: 200}
]
# [[0, 1337566253.89858, 0.000355720520019531], 3]
</pre></div>
</div>
<p>Here is the simple usage of <code class="docutils literal notranslate"><span class="pre">math_abs</span></code> function which returns nearest shops from office.</p>
<p>To detect nearest shops, we need to calculate distance.
If the distance of your office from station is 250 meters, you can calculate it by <code class="docutils literal notranslate"><span class="pre">math_abs(250</span> <span class="pre">-</span> <span class="pre">from_station)</span></code>.</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Shops --filter true --output_columns &#39;_key, from_office&#39; --scorer &#39;from_office = math_abs(250 - from_station)&#39; --sort_keys from_office
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         3
#       ],
#       [
#         [
#           &quot;_key&quot;,
#           &quot;ShortText&quot;
#         ],
#         [
#           &quot;from_office&quot;,
#           &quot;Int32&quot;
#         ]
#       ],
#       [
#         &quot;Cake &amp; Coffee Shop&quot;,
#         50
#       ],
#       [
#         &quot;Donut &amp; Coffee Shop&quot;,
#         150
#       ],
#       [
#         &quot;Coffee Shop&quot;,
#         200
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>By specifying <code class="docutils literal notranslate"><span class="pre">--sort_keys</span> <span class="pre">from_office</span></code>, you can show nearest shops by ascending order.</p>
</div>
<div class="section" id="parameters">
<h2><span class="section-number">7.15.13.4. </span>Parameters<a class="headerlink" href="#parameters" title="Permalink to this headline">¶</a></h2>
<p>There is only one required parameter.</p>
<div class="section" id="target">
<h3><span class="section-number">7.15.13.4.1. </span><code class="docutils literal notranslate"><span class="pre">target</span></code><a class="headerlink" href="#target" title="Permalink to this headline">¶</a></h3>
<p>Specifies a column of table that is specified by <code class="docutils literal notranslate"><span class="pre">table</span></code> parameter in <code class="docutils literal notranslate"><span class="pre">select</span></code>.</p>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.15.13.5. </span>Return value<a class="headerlink" href="#return-value" title="Permalink to this headline">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">math_abs</span></code> returns the absolute value of target column value.</p>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.15.13. <code class="docutils literal notranslate"><span class="pre">math_abs</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.15.13.1. Summary</a></li>
<li><a class="reference internal" href="#syntax">7.15.13.2. Syntax</a></li>
<li><a class="reference internal" href="#usage">7.15.13.3. Usage</a></li>
<li><a class="reference internal" href="#parameters">7.15.13.4. Parameters</a><ul>
<li><a class="reference internal" href="#target">7.15.13.4.1. <code class="docutils literal notranslate"><span class="pre">target</span></code></a></li>
</ul>
</li>
<li><a class="reference internal" href="#return-value">7.15.13.5. Return value</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="in_values.html"
                        title="previous chapter"><span class="section-number">7.15.12. </span><code class="docutils literal notranslate"><span class="pre">in_values</span></code></a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="now.html"
                        title="next chapter"><span class="section-number">7.15.14. </span>now</a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="now.html" title="7.15.14. now"
             >next</a> |</li>
        <li class="right" >
          <a href="in_values.html" title="7.15.12. in_values"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" ><span class="section-number">7.15. </span>Function</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.13. </span><code class="docutils literal notranslate"><span class="pre">math_abs</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>